// angle.c
//  ޥɥåǥ֥Ȥ򸫤٤ѹ
//- Feb 3 2003 -----------------------------------

#include <GL/glut.h>
#include <math.h>

int mouse_l = 0;
int mouse_m = 0;
int mouse_r = 0;

int mpos[2];  // mpos[0]=xɸ, mpos[1]=yɸ

double trans[3] = {0.0, 0.0, 0.0};
double theta[3] = {0.0, 0.0, 0.0};
double angle[3] = {0.0, 0.0, 0.0};

void display()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();

  glRotated(angle[0], 1.0, 0.0, 0.0);  // x 濴˲ž
  glRotated(angle[1], 0.0, 1.0, 0.0);  // y 濴˲ž
  glRotated(angle[2], 0.0, 0.0, 1.0);  // z 濴˲ž

  glutWireCone(1.0, 2.0, 5, 10);
  glutSwapBuffers();
}

void mouse(int button, int state, int x, int y)
{
  switch(button){
  case GLUT_LEFT_BUTTON:
    if(state == GLUT_DOWN){
      mpos[0] = x;
      mpos[1] = y;
      mouse_l = 1;
    }
    if(state == GLUT_UP){
      mouse_l = 0;
    }
    break;
  default:
    break;
  }
}

void motion(int x, int y)
{
  if(mouse_l == 1){
    theta[0] = (double)(y-mpos[1])/5.0;
    theta[1] = (double)(x-mpos[0])/5.0;
  }
  if(mouse_l == 1 || mouse_m == 1 || mouse_r == 1){
    mpos[0] = x;  // ܥ򲡤ƤȤ ޥxɸ
    mpos[1] = y;  // ܥ򲡤ƤȤ ޥyɸ
    angle[0] += theta[0];
    angle[1] += theta[1];
    glutPostRedisplay();
  }
}

void reshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w <= h)
        glOrtho(-2.0, 2.0, -2.0*(GLfloat)h/(GLfloat)w, 2.0*(GLfloat)h/(GLfloat)w, -10.0, 10.0);
    else
        glOrtho(-2.0*(GLfloat)w/(GLfloat)h, 2.0*(GLfloat)w/(GLfloat)h, -2.0, 2.0, -10.0, 10.0);
    glMatrixMode(GL_MODELVIEW);
}

int main(int argc, char **argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(500, 500);
  glutCreateWindow(argv[0]);

  glutReshapeFunc(reshape);
  glutDisplayFunc(display);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  
  glutMainLoop();
  return 0;
}
